/*
 *  -*- Mode: ANSI C -*-
 *  $Id: file.h,v 1.2 1996/08/16 17:23:20 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/file.h,v $
 *  Author: Fernandez, Gabriel
 *
 *  General functions to read and write files for the wavelet
 *  transforms. For now, only two formats are accepted pgm/ppm
 *  and the custom format for the program called wtf. The format
 *  recognized by the OpenFile function and from that point on all
 *  the other functions assume that format is used.
 */
/* do not edit anything above this line */

#ifndef __FILE_H__
#define __FILE_H__

#include <stdio.h>   /* for 'FILE *' type */
#include "flwtdef.h" /* for 'FileFormat' type */
#include "image.h"   /* for 'Image *' type */

/* Open filename with given options */
extern FILE *OpenFile ( const char *__filename, const char *__options );

/* Close file pointed by fp */
extern void CloseFile ( FILE *__fp );

/* Set output file type depending on default or forced value */
extern void SetOutputType ( char *__forcedType, const FileFormat __inputType,
                            Image *__image, const boolean __packets );

/* Read type of file for further operations */
extern FileFormat ReadFileType ( const char *__filename );

/* Read content of file pointed by fp */
extern int ReadFile ( char *__filename, const FileFormat __filetype,
                      Image *__image );

/* Write info in image into file pointed by fp */
extern int WriteFile ( char *__filename, const Image __image );

#endif /* __FILE_H__ */
