/*
 *  -*- Mode: ANSI C -*-
 *  $Id: flwtdef.h,v 1.16 1997/04/04 15:55:47 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/flwtdef.h,v $
 *  Author: Gabriel Fernandez
 *
 *  Contains declarations of global variables and type definitions.
 */
/* do not edit anything above this line */

#ifndef __FLWTDEF_H__
#define __FLWTDEF_H__

/* Identification */
#define REVDATE   "Version 1.0  Rev: " __DATE__
#define VERSTR    "1.0"

/* Default data directory (put '/' at the end) */
#define DATADIR   ""

/* Data type definitions */
#ifndef DOUBLE
#define DATA_TYPE float
#else
#define DATA_TYPE double
#endif
typedef          DATA_TYPE   Flt;
typedef          Flt *       Vector;
typedef          Vector *    Matrix;
typedef          Matrix *    Volume;
typedef short    int         boolean;
typedef unsigned char        byte;
typedef unsigned long        unlong;

/* General definitions */
#ifndef NULL
#define NULL       0L
#endif

#ifndef BUFSIZ
#define BUFSIZ   1024
#endif

#define MAX_FILENAME 256
#define MAX_FILETYPE   4

#ifndef _MAXFLOAT
#define _MAXFLOAT
#define MAXFLOAT        ((float)3.40282347e+38)
#endif
#define MAXDOUBLE       1.7976931348623157e+308
#define MINDOUBLE       2.2250738585072014e-308
#define MINFLOAT        ((float)1.17549435e-38)

/* ANSI macros */
#ifdef FLT_MAX
#define MAXFLOAT FLT_MAX
#endif
#ifdef DBL_MAX
#define MAXDOUBLE DBL_MAX
#endif

/* Boolean operators */
#define FALSE          0
#define TRUE           1

/* Exit error codes */
#define SUCCESS        0
#define MEMORY_ERROR   1
#define FILE_ERROR     2
#define INPUT_ERROR    3
#define GENERAL_ERROR  4

/* File format definitions */
/* Return values from ReadFileType()
 * Positive values are *definitely* readable formats.
 * Negative values are random files that FLWT can't read.
 */
typedef enum {
    FMT_ERROR    = -1,    /* couldn't open file, or whatever... */
    FMT_UNKNOWN  =  0,
    FMT_GIF      =  1,
    FMT_PBM      =  2,
    FMT_BMP      =  3,
    FMT_TXT      =  4,    /* simple ascii text */
    FMT_WTF      =  5     /* internal binary format */
} FileFormat;

/* List of save formats for the output files. */
typedef enum {
    F_GIF      = 0,
    F_PBMRAW   = 1,
    F_PBMASCII = 2,
    F_BMP      = 3,
    F_TXT      = 4,
    F_WTFWLT   = 6,
    F_WTFPCK   = 7
} SaveFormat;

#endif /* __FLWTDEF_H__ */
