/*
 *  -*- Mode: ANSI C -*-
 *  $Id: image.h,v 1.3 1996/08/16 17:23:25 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/image.h,v $
 *  Author: Gabriel Fernandez, Senthil Periaswamy
 *
 *  Useful definitions and macros to manipulate color and grayscale
 *  images.
 */
/* do not edit anything above this line */

#ifndef __IMAGE_H__
#define __IMAGE_H__

#include "flwtdef.h"

/* Global Structure for our image data type */
#define MAX_COLOR_PLANES 3

typedef enum {
    GREY  = 0,
    RED   = 0,
    GREEN = 1,
    BLUE  = 2
} Colors;

typedef struct
{
    Matrix band[MAX_COLOR_PLANES];   /* grayscale/color bands */
    int *levels,                     /* levels for the wavelet packet transform */
         blocks;                     /* number of decomposed regions */
    int symbols;                     /* number of symbols after quantization */
    int width,                       /* width of the image */
        height,                      /* height of the image */
        bpp,                         /* bits per pixel (1, 8, 24) */
        colType,                     /* def. Color type to save in
                                        (0 Color, 1 Grayscale, 2 B/W) */
        colorPlanes;                 /* color planes - 3 for rgb, 1 for gray scale */
    SaveFormat frmType;              /* def. Format type to save in */
    char fullInfo[128];              /* full info about input file */
    char shrtInfo[128];              /* brief info about input file */
    char *comment;                   /* comment text in outfile */
} Image;

/* Convenience macros */
#define IMG(image,plane,x,y) (image.band[(plane)][(y)][(x)])
#define IMG_PLANEPTR(image,plane) (&image.band[(plane)][0][0])

#endif /* __IMAGE_H__ */
