/*
 *  -*- Mode: ANSI C -*-
 *  $Id: imgmem.h,v 1.3 1996/08/16 17:23:26 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/imgmem.h,v $
 *  Author: Gabriel Fernandez, Senthil Periaswamy
 *
 *  High and low level functions to allocate contiguous memory
 *  for 2D and 1D vectors, and for image structures.
 */
/* do not edit anything above this line */

#ifndef __IMGMEM_H__
#define __IMGMEM_H__

#include "flwtdef.h"
#include "image.h"

/* High level image allocation */
extern boolean
IMG_InitMem ( Image *__img, const long __width, const long __height,
                            const int __colorPlanes, const int __bpp );
extern void
IMG_FreeMem ( Image __img );

/* Low level 1D/2D/3D buffer allocation */
extern Matrix *
MEM_Init3DC ( int __depth, long __width, long __height );
extern void
MEM_Free3DC ( Matrix *__buff );
extern Matrix *
MEM_Init3D ( int __depth, long __width, long __height );
extern void
MEM_Free3D ( Matrix *__buff, int depth );
extern Matrix
MEM_Init2D ( long __width, long __height );
extern void
MEM_Free2D ( Matrix __buff );
extern Vector
MEM_Init1D ( long __n );
extern void
MEM_Free1D ( Vector __buff );
extern Vector *
MEM_InitVecs ( int __depth, long __width );
extern void
MEM_FreeVecs ( Vector *__buff, int depth );

#endif /* __IMGMEM_H__ */
