/*
 *  -*- Mode: ANSI C -*-
 *  $Id: lift.h,v 1.2 1996/08/16 17:23:27 fernande Exp $
 *  $Source: /sgi.acct/sweldens/cvs/liftpack/include/lift.h,v $
 *  Author: Fernandez, Gabriel
 *
 *  Declares the functions that find the lifting coefficients used
 *  in the updating of the lambda coefficients.
 */
/* do not edit anything above this line */

#ifndef __LIFT_H__
#define __LIFT_H__

#include "flwtdef.h"

/* Initialize Integral-Moments matrices */
extern boolean
InitMoment ( const int __nTilde, const int __cols, const int __rows,
             const boolean __print_coeff );

/* Initialize Integral-Moments matrices */
extern void
FreeMoment ( const int __cols, const int __rows, const int __nTilde );

/* Update Integral-Moment matrices and calculate new Lifting coefficients */
extern void
GetLifting ( Vector __lifting, const Vector __filter, const int __step,
                               const int __N, const int __nTilde, const int __L,
                               const boolean __XYdir, const boolean __type );

#endif /* __LIFT_H__ */
