/*
 *  -*- Mode: ANSI C -*-
 *  $Id: memchk.h,v 1.4 1996/11/06 20:52:23 fernande Exp $
 *  $Header: /sgi.acct/sweldens/cvs/liftpack/include/memchk.h,v 1.4 1996/11/06 20:52:23 fernande Exp $
 *  Author: Sridhar, M. A.
 *  Modified: Gabriel Fernandez
 *
 *  Contains declarations of memory management functions to control
 *  memory leaks in a C source code.
 */
#ifndef __MEMCHK_H__
#define __MEMCHK_H__

#include <stdlib.h>

/* allocate memory and initialize it with zeros */
extern void *
Calloc (size_t __number, size_t __size, short __line_no, char* __file_name);

/* allocate a new memory block for a given pointer */
extern void *
Realloc (void* __ptr, size_t __size, short __line_no, char* __file_name);

/* allocate memory and keep track of important information */
extern void *
Malloc (size_t __size, short __line_no, char* __file_name);

/* free memory and delete entry in Malloc list */
extern void
Free (void* __p);

/* print content of Malloc list of allocations */
extern void
PrintLeaks ( void );

/* free memory pointed out by the Malloc list */
extern void
FreeLeaks ( void );

/* definitions for all programs to use Realloc, Calloc, Malloc, and Free */
#define calloc(n, s)  Calloc(n, s, __LINE__, __FILE__)
#define realloc(p, s) Realloc(p, s, __LINE__, __FILE__)
#define malloc(s)     Malloc(s, __LINE__, __FILE__)
#define free(s)       Free(s)

#endif /* __MEMCHK_H__ */
